interface/isl.py.top.*: explicitly cast self.ptr of Context to c_void_p
[barvinok.git] / README
blob344a595714e21de6233a17c771f3295f0be77e45
1 barvinok is a library for counting the number of integer points
2 in parametric and non-parametric polytopes as well as projections
3 of such sets.
4 For parametric polytopes the count is represented by either
5 an explicit function or a generating function.
6 The first comes in the shape of a piece-wise step-polynomial.
7 This is a generalization of both Ehrhart quasi-polynomials
8 and vector partition functions.
9 The second is a generalization of an Ehrhart series.
11 This library shares some functionality with LattE
12 (http://www.math.ucdavis.edu/~latte/)
13 and uses PolyLib (included), NTL (http://shoup.net/ntl/).
14 If you have cloned the git repository, you need to run
15         ./get_submodules.sh
16         sh autogen.sh
17 to get the submodules and create the configure scripts.
19 Additionally, the following packages can optionally be used
20 - Omega+ (http://chunchen.info/omega/)
21 - GLPK (http://www.gnu.org/software/glpk/)
23 NTL needs to have been compiled with GMP support.
24 That is, you have to specify
25     NTL_GMP_LIP=on
26 NTL also needs to have been compiled in ISO mode.
27 For versions older than 5.4, this means you need an additional
28     NTL_STD_CXX=on
30 Suppose you want to install everything in /opt,
31 Then you configure/compile NTL using
33 cd src
34 ./configure NTL_GMP_LIP=on PREFIX=/opt GMP_PREFIX=/path/to/gmp
35 make
36 make install
38 Configure this library using
40 ./configure --prefix=/opt --with-gmp-prefix=/path/to/gmp --with-ntl-prefix=/opt
42 If you want shared libraries, then configure with the
43 --enable-shared-barvinok option.
44 Note that this requires NTL to have been built as a shared library as well
45 (using "SHARED=on" on its configure line).
46 Also note that if you have previously installed a shared library of an older
47 version of barvinok, and you do not install one for this version, then the
48 linker may pick up the old shared library rather than the new static library.
50 By default, barvinok will use the included copy of isl.
51 If you want it to use a pre-installed version of isl instead, then
52 configure with the --with-isl=system option.  Use the --with-isl-prefix
53 option to specify the installation prefix of isl, if needed.
55 If you want to compile and use the included pet library, then
56 you need the following packages:
57 - libyaml (http://pyyaml.org/wiki/LibYAML)
58 - LLVM/clang (http://clang.llvm.org/get_started.html)
59 Additionally, you need to configure with the --with-pet=bundled option.
60 See pet/README for more information.
62 Then
64 make
65 make check
66 make install
68 If you want to put any one of these packages in the default location
69 (typically /usr/local), then the prefix argument can be omitted.
70 For more information on other arguments,
72 ./configure --help
74 The input format of barvinok_enumerate is the same as that
75 of testehrhart from the PolyLib distribution.
76 See the PolyLib manual, barvinok_enumerate.c or the
77 examples in tests/ehrhart/ .
79 Note that the fractional representation is subject to change.
81 The library supports three specialization algorithms.
82 The first performs a direct specialization using a random vector.
83 The second performs a "depth-first" incremental specialization.
84 The third performs a "breadth-first" incremental specialization.
86 The first is usually the fastest, but can fail if the random
87 vector happens to be chosen incorrectly.
88 The incremental algorithms should never fail, but can be slower,
89 in some cases by quite a bit.  The breadth-first version should
90 be faster than the depth-first version, especially on polytopes
91 of moderate dimension with a lot of "structure", but can require
92 more memory.
94 For bug reports, feature requests and questions,
95 contact http://groups.google.com/group/isl-development
97 Whenever you report a bug, please mention the exact version of barvinok
98 that you are using (output of "./iscc --version").  If you are unable
99 to compile barvinok, then report the git version (output of "git describe")
100 or the version included in the name of the tarball.